var express = require('express');
var app = express();
var http = require('http').Server(app);
var io = require('socket.io')(http);

app.get('/', function (req, res){
	res.sendFile(__dirname + '/index.html');
});
app.use(express.static(__dirname + ''));
app.get('*', function (req, res){
	res.send('<h1>404 - Nie znaleziono strony</h1>');
});

function randomInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

function randomString(length) {
    var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz'.split('');

    if (! length) {
        length = Math.floor(Math.random() * chars.length);
    }

    var str = '';
    for (var i = 0; i < length; i++) {
        str += chars[Math.floor(Math.random() * chars.length)];
    }
    return str;
}

var serverToken = randomString(10);

function Player () {
	this.x = null;
	this.y = null;
	this.color = null;
	this.id = null;
	this.nick = null;

	this.setColor = function (color) {
		this.color = color;
	}
	this.setNick = function (nick) {
		this.nick = nick;
	}
	this.setPosition = function (x, y) {
		this.x = x;
		this.y = y;
	}
}

io.on('connection', function (socket){
	socket.getID = function () {
		return '#' + socket.id.substr(0, 6);
	}
	socket.log = function (text) {
		console.log('[' + socket.getID() + '][' + socket.nick + '] ' + text);
	}

	socket.on('disconnect', function (){
		socket.log('disconnected');
	});

	socket.on('setNick', function (data){
		socket.join('position');
		socket.nick = data.nick;
		socket.log('Nick set to ' + data.nick);
		socket.x = randomInt(50, 300);
		socket.y = randomInt(50, 300);
		socket.emit('start', { x: socket.x, y: socket.y });
	});
	socket.on('move', function (data){
		socket.log('move ' + data.direction);
		speed = 5;
		if(data.direction == 'up') {
			socket.y -= speed;
		}else if(data.direction == 'right') {
			socket.x += speed;
		}else if(data.direction == 'down') {
			socket.y += speed;
		}else if(data.direction == 'left') {
			socket.x -= speed;
		}
	})
	// socket.on('position', function (data) {
	// 	if(socket.nick == undefined || data.x == null || data.y == null) {
	// 		socket.log('Cannot send position');
	// 		return false;
	// 	}
	// 	socket.log('position:' + data.x + ' ' + data.y)
		
	// 	socket.x = data.x;
	// 	socket.y = data.y;
	// 	// socket.broadcast.to('position').emit('position', {x: data.x, y: data.y, id: getID(), nick: socket.nick});
	// 	// io.to('position').emit('position', {x: data.x, y: data.y, id: getID(), nick: socket.nick});
	// 	// var clients = io.sockets.clients('position');
	// 	// console.log(clients);
	// });

	socket.nick = undefined;
	console.log('New user: ' + socket.getID());
	socket.emit('id', {'id': socket.getID()})
});


setInterval(function () {
	var c;
	var positions = [];
	var clients = Object.keys(io.sockets.sockets);

	for(i = 0; i < clients.length; i++) {
		c = io.sockets.sockets[clients[i]];
		positions.push({ id: c.getID(), nick: c.nick, x: c.x, y: c.y });
	}

	io.to('position').emit('positions', positions);
}, 50);

http.listen(3000, function (){
	console.log('Serwer - locahost:3000');
});